<?php

$pa = new Func;
$pa->input = $pa->input();
$pa->config = "config.php";

new Installer;

class Installer
{
        function installer()
        {        global $pa;

                if(filesize($pa->config) > 1 AND $pa->input['step'] < '3')
                {        $pa->do_print("Installer Locked", "As long as config.php contains data, the installer is automaticaly locked. <br><br><b>Upload a blank file over config.php to re-enable the installer.</b>");
                        exit;
                }

                switch($pa->input['step'])
                {        case '1':
                                $this->step1();
                                break;
                        case '2':
                                $this->step2();
                                break;
                        case '3':
                                $this->step3();
                                break;
                        default:
                                $this->welcome();
                                break;
                }

                $pa->do_print($this->title, $this->output);

        }

        function welcome()
        {        $this->title = "Welcome to SQL Photo Album!";
                $this->output = <<<data
Welcome to the SQL Photo Album installer. This installer is going to make it easier then ever to run a myiBF. You'll have it up in minutes!
<br><br>This installer will help you setup the MySQL tables, configuration file and an administrator account.
<br><br>This installer requires one simple step, after you click 'Proceed' button you'll be transfered to a form where you will need to enter
MySQL information, once this is done the script will install. Its that easy!<br>
If you are on a UNIX machine, CHMOD config.php, pic/, and pic/thumb/ 777 before proceding.
<br><br><center><font size='3'><a href='setup.php?step=1'>Proceed -></a></font></center>
data;
        }

        function step1()
        {        global $HTTP_SERVER_VARS;

                $url = str_replace( "/setup.php", "", $HTTP_SERVER_VARS['HTTP_REFERER']);

                if(!$url)
                {        $url = substr($HTTP_SERVER_VARS['SCRIPT_NAME'],0, -15);

                    if ($url == '')
                    {        $url == '/';        }
                    $url = 'http://'.$HTTP_SERVER_VARS['SERVER_NAME'].$url;
            }

        $this->title = "Configuration";
                $this->output = <<<data
<form method='post' action='setup.php'>
<input type='hidden' name='step' value='2'>
Please enter your MySQL Configuration and setup some basic configuration including an administrator account.
<br><br>
<b><font size='3'>MySQL Configuration</font></br>
<table width='100%'>
<tr><td width='40%'>MySQL Host (Normally 'localhost')</td>
<td width='60%'><input type='text' name='host' value='localhost' class='textinput'></td></tr>
<tr><td width='40%'>MySQL Database Name</td>
<td width='60%'><input type='text' name='dbname' class='textinput'></td></tr>
<tr><td width='40%'>MySQL Database Username</td>
<td width='60%'><input type='text' name='dbuser' class='textinput'></td></tr>
<tr><td width='40%'>MySQL Database User Password</td>
<td width='60%'><input type='text' name='dbpw' class='textinput'></td></tr>
<tr><td width='40%'> Table Prefix</td>
<td width='60%'><input type='text' name='pfx' value='pa_' class='textinput'></td></tr>
</table>
<br>
<b><font size='3'>Script Configuration</font></br>
<table width='100%'>
<tr><td width='40%'>Script Name</td>
<td width='60%'><input type='text' name='name' value='My Gallery' class='textinput'></td></tr>
<tr><td width='40%'>Script URL</td>
<td width='60%'><input type='text' name='url' value='{$url}/' class='textinput'></td></tr>
<tr><td width='40%'>Admin Username</td>
<td width='60%'><input type='text' name='user' class='textinput'></td></tr>
<tr><td width='40%'>Admin Password</td>
<td width='60%'><input type='password' name='password' class='textinput'></td></tr>
<tr><td width='40%'>Confirm Admin Password</td>
<td width='60%'><input type='password' name='password2' class='textinput'></td></tr>
<tr><td colspan='2' align='center'><br><input type='submit' value='Install List!' class='submit'></td></tr>
</table>
</form>
data;
        }

        function step2()
        {        global $pa, $HTTP_SERVER_VARS;

            if(!isset($pa->input['error']))
            {
                $req = array ("host", "dbname", "dbuser", "name", "url", "user", "password", "password2");

                foreach($req as $n)
                {        if($pa->input[$n] == "")
                        {        $this->title = "Error";
                        $this->output = "All fields are required except for Database Password and Prefix. Please go back and try again.";
                        return;        }
                }

                if($pa->input['password'] != $pa->input['password2'])
                {        $this->title = "Error";
                        $this->output = "Your two password field do not match. Please try again.";
                        return;                }


                @mysql_connect($pa->input['host'], $pa->input['dbuser'], $pa->input['dbpw']) OR $error = 1;

                if($error == 1)
                {        $this->title = "Error";
                        $this->output = "Database Host Name, Username or Password is incorrect. Please try again";
                        return;        }

                if(!mysql_select_db($pa->input['dbname']))
                {        $this->title = "Error";
                        $this->output = "Cannot connect to the Database. This is due to an incorrect 'Database Name'";
                        return;
                }

                $file = "<? ".'$config'." = \"{$pa->input['host']},{$pa->input['dbuser']},{$pa->input['dbpw']},{$pa->input['dbname']},{$pa->input['pfx']},1\"; ?>";

                if ( $fo = fopen( $pa->config, 'a' ) )
                {        fputs($fo, $file, strlen($file) );
                         fclose($fo);        }
                else
                {        $this->title = "Error";
                        $this->output = "Cannot write to \"config.php\". This should be a blank file in the root of your SQL Photo Album directory. On *nix it needs CHMOD 777.";
                }

                @chmod($pa->config, 666);

                $pf = $pa->input['pfx'];

                $sql = $pa->build_sql();
                foreach($sql as $q)
                {        // Major fix is the addition to add '1' to stop looping of the replace, at the end
                        if ($pf != "pa_")
                       {        $q = preg_replace("/pa_(\S+?)([\s\.,]|$)/", $pf."\\1\\2", $q, 1);        }

        if ( preg_match("/CREATE TABLE (\S+) \(/", $q, $match) )
        {
                if ($match[1])
                {
                        $the_query = "DROP TABLE if exists ".$match[1];
                        if (! mysql_query($the_query) )
                        {        $this->title = "Error";
                                        $this->output = "A mySQL error has occured. (".mysql_error().")";
                                return;
                                }
                }
        }

                if (!mysql_query($q) )
        {        $this->title = "Error";
                        $this->output = "A mySQL error has occured. (".mysql_error().")";
                        return;
        }
                }

                $url = str_replace("setup.php?step=1", "", $HTTP_SERVER_VARS['HTTP_REFERER']);

                if(!$url)
                {        $url = substr($HTTP_SERVER_VARS['SCRIPT_NAME'],0, -15);

                    if ($url == '')
                    {        $url == '/';        }
                    $url = 'http://'.$HTTP_SERVER_VARS['SERVER_NAME'].$url;
                }

                mysql_query("INSERT INTO {$pf}admin VALUES ('','{$pa->input['user']}','".md5($pa->input['password'])."')") OR $error = 9;

                $insert = array (
                'id'        =>        '1',
'filename'        =>        'index.php',
'status'        =>        '1',
'status_reason'        =>        'List is now off.',
'enable_gzip'        =>        '1',
'header_show'        =>        '0',
'header_cach'        =>        '0',
'header_nt'        =>        '0',
'cookie_name'        =>        'pa_',
'cookie_secure'        =>        '0',
'date_long'        =>        'l dS F Y, g:iA',
'date_short'        =>        'd-m-y',
'date_mid'        =>        'd-m-y, g:iA',
'date_adjust2'        =>        '0',
'date_adjust'        =>        '0',
'tn_width'			=>			'100',
'tn_height'			=>			'100',
'pic_ex'        =>        'gif,jpg,png,',
'pic_size'        =>        '1000000',
'pic_path'        =>        'pic/',
'pic_http'        =>        $url.'pic/',
'pic_upload'        =>        '0',
'pic_link'        =>        '1',
'list_order'        =>        'viewed',
'enable_comments'        =>        '1',
'enable_viewed'        =>        '1',
'enable_viewed_record'        =>        '1',
'enable_rating'        =>        '1',
'pasql_name'        =>        $pa->input['name'],
'pasql_url'        =>        $pa->input['url'],
'pasql_owner_name'        =>        'Owner Name',
'pasql_owner_email'        =>        'owner@domain.com',
'skin_names'        =>        '1:Default Skin',
'skin_choice'        =>        '1',
'skin_selectable'        =>        '0',
'lang_names'        =>        '1:English',
'lang_choice'        =>        '1',
'lang_selectable'        =>        '0',
'debug_1'        =>        '1',
'max_load'        =>        '25',
'pics_per_row'       =>           '5',
'pics_per_col'       =>           '3',
'categ_per_row'       =>           '3',
                );

                $insert = $pa->insert($insert);
                mysql_query("INSERT INTO {$pf}config ($insert[columns]) VALUES ($insert[values])") OR $error = 10;

                if($error == 9)
                {
                 $this->output = <<<data
<h1>Error inserting admin row</h1>
data;
return;
				}
                if($error == 10)
                {
                 $this->output = <<<data
<h1>Error inserting config row</h1>
data;
return;
				}

                $this->title = "SQL Photo Album Registeration";
                $this->output .= <<<data
Your mySQL tables have been created successfully, along with your mySQL Configuration creation.
<br><br>
The next step is to register your SQL Photo Album. You must be on the internet to do so, fill out this form, it will submit to
the SQL Photo Album servers. Then it will automatically redirect you back to the installer. You must do this for every installation as part of the license.
<br><br>If an unregistered site is found using SQL Photo Album, their license will be revoked.
<br><br>
<form method='post' action='http://dan.osipov.org/photosql/register.php'>
<input type='hidden' name='redirect' value='{$url}setup.php'>
<input type='hidden' name='url2' value='{$url}'>
<input type='hidden' name='version' value='201'>
<input type='hidden' name='prodid' value='pl5645468524'>
<b><font size='3'>SQL Photo Album Registeration</font></br>
<table width='100%'>
<tr><td width='40%'>Name</td>
<td width='60%'><input type='text' name='name' class='textinput'></td></tr>
<tr><td width='40%'>E-Mail</td>
<td width='60%'><input type='text' name='email' class='textinput'></td></tr>
<tr><td width='40%'>SQL Photo Album Name</td>
<td width='60%'><input type='text' name='site_name' class='textinput'></td></tr>
<tr><td width='40%'>SQL Photo Album URL</td>
<td width='60%'><input type='text' name='url' class='textinput' value="{$url}index.php"></td></tr>
<tr><td width='40%'>SQL Photo Album Description</td>
<td width='60%'><input type='text' name='desc' class='textinput'></td></tr>
<tr><td colspan='2' align='center'><br><input type='submit' value='Submit Registeration' class='submit'></td></tr>
</table>
data;

			}
            else
            {
            	$this->title = "SQL Photo Album Registeration";
                $this->output .= <<<data
Your mySQL tables have been created successfully, along with your mySQL Configuration creation.
<br><br>
<font color=red>Please fill in all fields</font><br><br>
The next step is to register your SQL Photo Album. You must be on the internet to do so, fill out this form, it will submit to
the SQL Photo Album servers. Then it will automatically redirect you back to the installer. You must do this for every installation as part of the license.
<br><br>If an unregistered site is found using SQL Photo Album, their license will be revoked.
<br><br>
<form method='post' action='http://dan.osipov.org/photosql/register.php'>
<input type='hidden' name='redirect' value='{$url}setup.php'>
<input type='hidden' name='url2' value='{$url}'>
<input type='hidden' name='version' value='200'>
<input type='hidden' name='prod' value='personal'>
<b><font size='3'>SQL Photo Album Registeration</font></br>
<table width='100%'>
<tr><td width='40%'>Name</td>
<td width='60%'><input type='text' name='name' class='textinput'></td></tr>
<tr><td width='40%'>E-Mail</td>
<td width='60%'><input type='text' name='email' class='textinput'></td></tr>
<tr><td width='40%'>SQL Photo Album Name</td>
<td width='60%'><input type='text' name='site_name' class='textinput'></td></tr>
<tr><td width='40%'>SQL Photo Album URL</td>
<td width='60%'><input type='text' name='url' class='textinput' value="{$url}index.php"></td></tr>
<tr><td width='40%'>SQL Photo Album Description</td>
<td width='60%'><input type='text' name='desc' class='textinput'></td></tr>
<tr><td colspan='2' align='center'><br><input type='submit' value='Submit Registeration' class='submit'></td></tr>
</table>
data;
			}

        }

        function step3()
        {        $this->title = "Installation Complete";
                $this->output = <<<data
Congratulations, SQL Photo Album has installed successfully. Your registration of the software has also been submited.
<br><br>
The installer has already been locked (automatically) but it is suggested that you delete the file 'setup.php' off your server anyway.
<br><br>
You may want to <a href='index.php'>Visit Your List</a>, or log into your <a href='admin.php'>Admin CP</a>.
data;
        }

}

class Func {

        function do_print($title, $output)
        {        print <<<data
                <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>

<title>SQL Photo Album Installer - $title</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<style type="text/css">
<!--
td {
        font-family: Verdana, Arial, Helvetica, sans-serif;
        font-size: 12px;
}
.submit {
        background-color: #CFCFC1;
        color: #000000;
        font-family: Verdana, Arial, Helvetica, sans-serif;
        font-size:11px
}
.textinput {
        background-color: #F8F8F2;
        color:#000000;
        font-family: Verdana, Arial, Helvetica, sans-serif;
        font-size:10px;
        width: 95%;
}

.date {
        background-color: #F8F8F2;
        color:#000000;
        font-family: Verdana, Arial, Helvetica, sans-serif;
        font-size:10px;
}
.error {
        font-weight: bold;
        color: #FF0000;
        font-size: 18px
}
.title {
        font-size: 16px;
        font-weight: bold;
        font-variant: small-caps;
}

.border {
        border: 1px dashed #000000;
}

a:link, a:visited, a:active {
        text-decoration: none;
        color: #C43ABE;
        font-weight: bold;
}
a:hover {
                text-decoration: underline;
}

-->
</style>
</head>
<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0" bgcolor="#3AC485">
<div align="center">
  <center>
<table Width="65%" Border=0 CellPadding=0 CellSpacing=0>
  <tr>
    <td width="7"> <img Src="skin/admin_images/admintext_01.jpg" Width=7 Height=30 Alt=""></td>
    <td height="30" background="skin/admin_images/admintext_03.jpg" valign="middle"><table width="93%" border="0" cellspacing="0" cellpadding="0">
      <tr>
        <td width="26"><img src="skin/admin_images/admintext_02.jpg" width="26" height="30"></td>
        <td valign="middle"><b><font face="Verdana" size="2">SQL Photo Album Installer - $title</font></b></td>
      </tr>
    </table></td>
    <td width="9"> <img Src="skin/admin_images/admintext_04.jpg" Width=9 Height=30 Alt=""></td>
  </tr>
  <tr>
    <td background="skin/admin_images/admintext_05.jpg"></td>
    <td bgcolor="#86DBB4">$output </td>
    <td background="skin/admin_images/admintext_06.jpg"></td>
  </tr>
  <tr>
    <td> <img Src="skin/admin_images/admintext_07.jpg" Width=7 Height=5 Alt=""></td>
    <td background="skin/admin_images/admintext_08.jpg" height="5"></td>
    <td> <img Src="skin/admin_images/admintext_09.jpg" Width=9 Height=5 Alt=""></td>
  </tr>
</table>
</center>
</div>
</body>
</html>
data;

        }

        function insert($data)
        {
                foreach($data as $n => $v)
                {
                        $columns[] = $n;
                        $rows[] = "'" . addslashes($v) . "'";

                }
                return array (
                                                'columns' => implode(",", $columns),
                                                'values' => implode(",", $rows),
                );
        }

        function input()
        {        global $HTTP_GET_VARS, $HTTP_POST_VARS;

                if(is_array($HTTP_GET_VARS))        {
                foreach($HTTP_GET_VARS as $n => $v)
                {        $return[$n] = $v;        }        }

                if(is_array($HTTP_POST_VARS))        {
                foreach($HTTP_POST_VARS as $n => $v)
                {        $return[$n] = $v;        }        }

                return $return;
        }

        function build_sql()
        {        $sql[] = "CREATE TABLE pa_config (
  id int(11) NOT NULL auto_increment,
  filename varchar(250) NOT NULL default '',
  status tinyint(4) NOT NULL default '1',
  status_reason tinytext NOT NULL,
  enable_gzip tinyint(4) NOT NULL default '1',
  header_show tinyint(4) NOT NULL default '0',
  header_cach tinyint(4) NOT NULL default '0',
  header_nt tinyint(4) NOT NULL default '0',
  cookie_name varchar(250) NOT NULL default '',
  cookie_time varchar(250) NOT NULL default '',
  cookie_path varchar(100) NOT NULL default '',
  cookie_domain varchar(150) NOT NULL default '',
  cookie_secure tinyint(4) NOT NULL default '0',
  date_long varchar(100) NOT NULL default '',
  date_short varchar(100) NOT NULL default '',
  date_mid varchar(250) NOT NULL default '',
  date_adjust2 int(11) NOT NULL default '0',
  date_adjust int(11) NOT NULL default '0',
  tn_width int(11) NOT NULL default '0',
  tn_height int(11) NOT NULL default '0',
  pic_ex text NOT NULL,
  pic_size int(11) NOT NULL default '0',
  pic_path varchar(250) NOT NULL default '',
  pic_http varchar(250) NOT NULL default '',
  pic_upload tinyint(4) NOT NULL default '0',
  pic_link tinyint(4) NOT NULL default '1',
  list_order varchar(250) NOT NULL default '',
  append_comments tinyint(4) NOT NULL default '0',
  enable_comments tinyint(4) NOT NULL default '1',
  enable_viewed tinyint(4) NOT NULL default '1',
  enable_viewed_record int(11) NOT NULL default '1',
  enable_rating tinyint(4) NOT NULL default '1',
  pasql_name varchar(250) NOT NULL default '',
  pasql_url varchar(250) NOT NULL default '',
  pasql_owner_name varchar(250) NOT NULL default '',
  pasql_owner_email varchar(250) NOT NULL default '',
  skin_names tinytext NOT NULL,
  skin_choice int(11) NOT NULL default '1',
  skin_selectable tinyint(4) default '1',
  lang_names varchar(250) NOT NULL default '',
  lang_choice int(11) NOT NULL default '1',
  lang_selectable tinyint(4) NOT NULL default '1',
  debug_1 tinyint(4) NOT NULL default '0',
  debug_2 tinyint(4) default '0',
  debug_3 tinyint(4) NOT NULL default '0',
  max_load int(11) NOT NULL default '25',
  session_time int(11) NOT NULL default '3600',
  pics_per_row int(15) NOT NULL default '0',
  pics_per_col int(15) NOT NULL default '0',
  categ_per_row int(15) NOT NULL default '0',
  biography text NOT NULL,
  site_url varchar(250) NOT NULL default '',
  allow_guest_email tinyint(4) NOT NULL default '1',
  mail_comments tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (id),
  UNIQUE KEY date_short (date_short)
) TYPE=MyISAM";

$sql[] = "CREATE TABLE pa_admin (
  id int(11) NOT NULL auto_increment,
  username varchar(250) NOT NULL default '',
  password varchar(50) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM
";

$sql[] = "CREATE TABLE pa_comments (
  id int(11) NOT NULL auto_increment,
  pic_id int(11) NOT NULL default '0',
  date varchar(20) default NULL,
  name varchar(250) NOT NULL default '',
  email varchar(250) NOT NULL default '',
  ip varchar(250) NOT NULL default '',
  message text,
  PRIMARY KEY  (id)
) TYPE=MyISAM
";

$sql[] = "
CREATE TABLE pa_sessions (
  id varchar(40) NOT NULL default '0',
  ip varchar(25) default NULL,
  last_activity varchar(20) default NULL,
  user_id varchar(250) NOT NULL default '',
  admin tinyint(4) NOT NULL default '0'
) TYPE=MyISAM
";

$sql[] = "
CREATE TABLE pa_pictures (
  id int(11) NOT NULL auto_increment,
  name varchar(250) NOT NULL default '',
  description text NOT NULL,
  category_id int(11) NOT NULL default '0',
  date varchar(50) NOT NULL default '',
  rating int(11) NOT NULL default '0',
  n_rating int(11) NOT NULL default '0',
  rating_users text NOT NULL,
  viewed int(11) NOT NULL default '0',
  viewed_reset int(11) NOT NULL default '0',
  viewed_users text NOT NULL,
  open tinyint(4) NOT NULL default '0',
  KEY id (id)
) TYPE=MyISAM
";

$sql[] = "
CREATE TABLE pa_category (
  id int(11) NOT NULL auto_increment,
  name varchar(250) NOT NULL default '',
  under_id int(11) NOT NULL default '',
  description text NOT NULL,
  KEY id (id)
) TYPE=MyISAM
";

$sql[] = "
CREATE TABLE pa_stquery (
  id varchar(50) NOT NULL default '',
  ip varchar(25) default NULL,
  query text NOT NULL,
  KEY id (id)
) TYPE=MyISAM
";

return $sql;

        }

}


?>